# ruby code to evaluate statistics of seating by gender and (coarse-grained) field, to demonstrate the generation of a null model by shuffling (in this case) without replacement
# Suggestions, extensions, and thoughts technical or conceptual both welcome and solicited.
# This code is *not debugged* and not for distribution beyond CSSS 2012.

# Simon DeDeo, Santa Fe Institute, 14 June 2012
# simon@santafe.edu

file=File.new("seating.dat", 'r')

letters=["A", "B", "C", "D"]

list=[]
file.each_line { |i|
  running=[]
  line=i.split("\t")
  running += [[letters.index(line[0][0]), line[0][1].to_i]]
  1.upto(line.length-1) { |j|
    person=line[j].split(" ")
    running += [[person[0], person[1]]]
  } 
  list += [running]
}

file.close


list_simple=[]
list.each { |i|
  1.upto(i.length-1) { |person|
    list_simple += [[i[0], i[person]]]
  }
}

professions=list_simple.collect { |i|
  i[1][1]
};1
professions=(professions & professions)

group_math=["appliedmath", "physics", "engineering", "cs", "statistics", "math", "aerospace", "materialsci", "physics-economics"]
group_cog=["cogsci", "ai", "neuro", "inquirymethology", "language", "neuroscience", "linguistics"]
group_bio=["ecology", "paleontology", "medicine", "genetics", "climatescience", "epidemeology", "soilscience", "biology", "environengineering"]
group_soc=["literature", "economics", "archaeology", "politicalscience", "sociology", "publicpolicy"]
g_list=[group_math, group_cog, group_bio, group_soc]

def field_match(field, g_list)
  if g_list[0].include?(field) then
    return "M"
  end
  if g_list[1].include?(field) then
    return "C"
  end
  if g_list[2].include?(field) then
    return "B"
  end
  if g_list[3].include?(field) then
    return "S"
  end  
end


class Array
  def total
    self.inject(0) { |num, i|
      num + i
    }
  end
  
  def mean
    self.total/(1.0*self.length)
  end
end

def distance(g1, g2)
  (g1[0]-g2[0]).abs+(g1[1]-g2[1]).abs
end

def avg_distance(list_simple, typeA, typeB)
  avg=0
  n=0
  0.upto(list_simple.length-2) { |i|
    (i+1).upto(list_simple.length-1) { |j|
      if ((list_simple[i][1][0] == typeA) and (list_simple[j][1][0] == typeB)) or ((list_simple[i][1][0] == typeB) and (list_simple[j][1][0] == typeA)) then
        # print "Pair found!\n"
        # print "#{list_simple[i]} and #{list_simple[j]} (distance: #{distance(list_simple[i][0], list_simple[j][0])})\n"
        n += 1
        avg += distance(list_simple[i][0], list_simple[j][0])
      end
    }
  }
  avg/(1.0*n)
end

def avg_field_distance(list_simple, typeA, typeB, g_list)
  avg=0
  n=0
  0.upto(list_simple.length-2) { |i|
    (i+1).upto(list_simple.length-1) { |j|
      if ((field_match(list_simple[i][1][1], g_list) == typeA) and (field_match(list_simple[j][1][1], g_list) == typeB)) or ((field_match(list_simple[i][1][1], g_list) == typeB) and (field_match(list_simple[j][1][1], g_list) == typeA)) then
        # print "Pair found!\n"
        # print "#{list_simple[i]} and #{list_simple[j]} (distance: #{distance(list_simple[i][0], list_simple[j][0])})\n"
        n += 1
        avg += distance(list_simple[i][0], list_simple[j][0])
      end
    }
  }
  avg/(1.0*n)
end


def make_null(list_simple)
  list_new=list_simple.collect { |i|
    [i[0].dup]
  }
  list_simple.length.times { |j|
    list_new[j] += [list_simple[rand(list_simple.length)][1]]
  }
  list_new
end

file=File.new("bb_null.dat", 'w')
file.write("#{avg_field_distance(list_simple, "B", "B", g_list)}\n")
bb_null=Array.new(1000) {
  avg_field_distance(make_null(list_simple), "B", "B", g_list)
}; 1
bb_null.each { |i|
  file.write("#{i}\n")
}; 1
file.close


file=File.new("mm_null.dat", 'w')
file.write("#{avg_distance(list_simple, "M", "M")}\n")
mm_null=Array.new(1000) {
  avg_distance(make_null(list_simple), "M", "M")
}; 1
mm_null.each { |i|
  file.write("#{i}\n")
}; 1
file.close

file=File.new("mf_null.dat", 'w')
file.write("#{avg_distance(list_simple, "M", "F")}\n")
mf_null=Array.new(1000) {
  avg_distance(make_null(list_simple), "M", "F")
}; 1
mf_null.each { |i|
  file.write("#{i}\n")
}; 1
file.close

file=File.new("ff_null.dat", 'w')
file.write("#{avg_distance(list_simple, "F", "F")}\n")
ff_null=Array.new(1000) {
  avg_distance(make_null(list_simple), "F", "F")
}; 1
ff_null.each { |i|
  file.write("#{i}\n")
}; 1
file.close

list=["M", "C", "B", "S"]
file=File.new("field_null.dat", 'w')
0.upto(3) { |i|
  i.upto(3) { |j|
    file.write("#{avg_field_distance(list_simple, list[i], list[j], g_list)} ")
  }
}
file.write("\n")
Array.new(1000) { |k|
  print "Doing #{k}\n"
  list_null=make_null(list_simple)
  0.upto(3) { |i|
    i.upto(3) { |j|
      file.write("#{avg_field_distance(list_null, list[i], list[j], g_list)} ")
    }
  }
  file.write("\n")
}; 1
file.close


mm_mean=Array.new(1000) {
  avg_distance(make_null(list_simple), "M", "M")
}.mean
mf_mean=Array.new(1000) {
  avg_distance(make_null(list_simple), "M", "F")
}.mean
ff_mean=Array.new(1000) {
  avg_distance(make_null(list_simple), "F", "F")
}.mean

file=File.new("hypernorm_null.dat", 'w')
file.write("#{((avg_distance(list_simple, "M", "M")-mm_mean)**2 + (avg_distance(list_simple, "M", "F")-mf_mean)**2 + (avg_distance(list_simple, "F", "F")-ff_mean)**2)/3.0}\n")
Array.new(1000) {
  null_list=make_null(list_simple)
  file.write("#{((avg_distance(null_list, "M", "M")-mm_mean)**2 + (avg_distance(null_list, "M", "F")-mf_mean)**2 + (avg_distance(null_list, "F", "F")-ff_mean)**2)/3.0}\n")
}; 1
file.close




